package
{
    import loom.Application;
    import loom2d.display.StageScaleMode;
    import loom2d.display.Image;

    import loom2d.textures.Texture;
    import loom2d.ui.SimpleLabel;
    import loom2d.events.KeyboardEvent;

    import loom2d.math.Point;
    import loom2d.math.Rectangle;
    import loom2d.math.Color;

    import loom.gameframework.TimeManager;
    import loom.gameframework.ITicked;
    import loom.gameframework.IAnimated;


    import loom.platform.LoomKey;

    import loom2d.display.Quad;


    public class shepCollectable extends shepActor
    {
        public var bIncreasePlayerPowerLevel:boolean;
        public var value:int;

        public var bDriftTowardsPlayer:boolean;

        public var fLifetime:float;

        public var alreadyCollectedGoAway:boolean;

        public var bActive:boolean;


        public override function RegisterDrawElements( app:LD48Game ):void
        {

            app.GetStage().addChild(sprite);
        }

        public override function UnRegisterDrawElements( app:LD48Game ):void
        {
            app.GetStage().removeChild(sprite);
            bActive = false;
        }

        public override function onTick():void
        {
            super.onTick();

            var theGame:LD48Game = theUtilities.theGame;

            if( bDriftTowardsPlayer )
            {
                var pship:shepPlayerShip = theGame.playerShip;

                var deltaVec:Point = pship.worldPosition - worldPosition;
                var force:float = 200;
                force += 1000 - deltaVec.length;
                if( force < 300 )
                    force = 300;

                deltaVec.normalize(force);
                deltaVec.y *= -1;
                thrust = deltaVec;

                fLifetime += deltaMS;
                if( fLifetime > 3.0)
                    moveFriction = 200 + (200 * (fLifetime- 3.0));

                if( moveFriction > 600)
                    moveFriction = 600;

                if( fLifetime > 8.0)
                {
                    moveFriction = 0;
                    var badCode:Point = pship.worldPosition - worldPosition;
                    badCode.normalize(1);
                    moveVelocity.x = 1000.0 * badCode.x;
                    moveVelocity.y = 1000.0 * badCode.y;
                }
            }
        }


        override function DoCollisionTick( oldPos:Point)
        {
            //other stuff checks if it collides into us

        }
    }
}