package
{
    import loom.Application;
    import loom2d.display.StageScaleMode;
    import loom2d.display.Image;

    import loom2d.textures.Texture;
    import loom2d.ui.SimpleLabel;
    import loom2d.events.KeyboardEvent;

    import loom2d.math.Point;
    import loom2d.math.Rectangle;
    import loom2d.math.Color;

    import loom.gameframework.TimeManager;
    import loom.gameframework.ITicked;

    import loom.platform.LoomKey;

    import loom2d.display.Quad;

    public class shepEnemy extends shepCharacter
    {
        public var coinValue:int;
        public var strSpriteName:string;

        public var damageOnCollision:int;

        public var noCollide:boolean;

        public var coinTossBoost:float;

        override public function UnRegisterDrawElements( app:LD48Game )
        {
            super.UnRegisterDrawElements( app );
        }

        override public function onTick():void
        {
            super.onTick();
            if( theUtilities.theGame.gameState != 2 || theUtilities.theGame.playerShip == null)
            {
                theUtilities.theGame.UnRegisterShepObject( this );
                return;
            }

            var distFromPlayer:Point = worldPosition - theUtilities.theGame.playerShip.worldPosition;
            if( distFromPlayer.length > 2400 )
            {
                trace("too far! " + distFromPlayer.length);
                health = 0;
                theUtilities.theGame.UnRegisterShepObject( this );
            }
        }

        public function OnDeath():void
        {
            var theGame:LD48Game = theUtilities.theGame;
            var loop:int;
            var coinMax:int = coinValue;

            if( coinMax >= 10 )
            {
                for( loop = 0; loop < coinMax/5; loop ++)
                {
                    theGame.SpawnCoin( worldPosition, new Point( (-100-coinTossBoost) + Math.random() * (200 + coinTossBoost), (-100-coinTossBoost) + Math.random() * (200 + coinTossBoost)), 5);
                    coinValue -= 5;
                    if( coinValue < 5)
                        break;
                }
            }

            for( loop = 0; loop < coinValue; loop ++)
            {
                theGame.SpawnCoin( worldPosition, new Point( -100 + Math.random() * 200, -100 + Math.random() * 200), 1);
            }

            for( var t:int =0 ; t < 12; t++)
            {
                theGame.SpawnQuadParticle( worldPosition,  new Point( -100 + Math.random() * 200, -100 + Math.random() * 200), new Point(0,0), 0.5, new Color(255,165,0,255), 2.0,2.0,1.0 );
            }
        }

        override public function Init( app:LD48Game ):void
        {
            faction = 0;

            sprite = new Image(Texture.fromAsset("assets/" + strSpriteName + ".png"));

            moveVelocity = new Point(0,0);
            moveVelocity.x = (-1.0 + Math.random() * 2.0) * baseMovespeed;
            moveVelocity.y = (-1.0 + Math.random() * 2.0) * baseMovespeed;
            sprite.center();
            
        }

        public function FireShotAtPlayer( wiggle:float, bulletSpeed:float, damage:int ):void
        {
            var theGame = theUtilities.theGame;
            var deltaVec = theGame.playerShip.worldPosition - worldPosition;
            deltaVec.normalize(1);
            deltaVec.x += (-wiggle/2) + (Math.random() * wiggle);
            deltaVec.y += (-wiggle/2) + (Math.random() * wiggle);
            //trace("enemy shot! " + deltaVec );

            theGame.LaunchEnemyBullet( this, new Point(0,0), 0.0, deltaVec, bulletSpeed, damage);
            //LaunchEnemyBullet( launcher:shepCharacter, offset:Point, offsetDist:float, launchDir:Point, speed:float, damage:float):void
        }

        public function ThrustTowardPlayer( speed:float ):Point
        {
            var theGame = theUtilities.theGame;
            if( theGame.gameState != 2 || theGame.playerShip == null)
                return new Point(0,0);


            var pship:shepPlayerShip = theGame.playerShip;

            var deltaVec:Point = pship.worldPosition - worldPosition;
            deltaVec.normalize(speed);
            deltaVec.y *= -1;
            thrust = deltaVec;

            //trace("Enemy thuruustuu! " + thrust);
            return deltaVec;

        }

    }

    public class shepEnemy_Type2 extends shepEnemy
    {

        override public function Init( app:LD48Game ):void
        {
            strSpriteName = "enemy_2";
            coinValue = 2;
            health = 10;
            maxHealth = 10;
            baseMovespeed = 100.0;
            damageOnCollision = 1;
            super.Init(app);

        }
    }


    public class shepEnemy_Type3 extends shepEnemy
    {
        var bInThrustMode:boolean;
        var fTimer1:float;

        override public function Init( app:LD48Game ):void
        {
            strSpriteName = "enemy_3";
            coinValue = 3;
            baseMovespeed = 300.0;
            health = 20;
            maxHealth = 20;
            damageOnCollision = 2;

            super.Init(app);

            fTimer1 = 4.0 + Math.random() * 2.0;

            moveFriction = 100.0;
        }

        override public function onTick():void
        {

            var theGame = theUtilities.theGame;

            if( theGame.gameState != 2 || theGame.playerShip == null)
                return;

            var moveVec:Point = moveVelocity;
            moveVec.normalize();

            sprite.rotation = (theUtilities.GetAngleFromVector( moveVec ) / 360) * 6.28;

            if( bInThrustMode )
            {
                ThrustTowardPlayer(800.0);
                if( Math.random() < 0.2 )
                {
                    SpawnThrustParticle();
                    SpawnThrustParticle();
                }
            }
            else
            {
                thrust.x = 0;
                thrust.y = 0;
            }

            super.onTick();

            fTimer1 -= deltaMS;
            if( fTimer1 <= 0 )
            {
                bInThrustMode = !bInThrustMode;
                if( bInThrustMode )
                    fTimer1 = 1.0;
                else
                    fTimer1 = 3.0 + Math.random() * 2.0;
            }

        }
    }

    public class shepEnemy_Type4 extends shepEnemy
    {

        override public function Init( app:LD48Game ):void
        {
            health = 40;
            maxHealth = 40;
            strSpriteName = "enemy_4";
            coinValue = 4;
            damageOnCollision = 10;
            baseMovespeed = 100.0;
            super.Init(app);

        }

        override public function OnDeath():void
        {

            var theGame:LD48Game = theUtilities.theGame;
            super.OnDeath();

            theGame.SpawnEnemy(2, worldPosition);
            theGame.SpawnEnemy(2, worldPosition);

        }
    }

    public class shepEnemy_Type5 extends shepEnemy
    {
        var bInThrustMode:boolean;
        var fTimer1:float;
        var bThrustingAway:boolean;

        var fShotTimer:float;


        override public function Init( app:LD48Game ):void
        {
            strSpriteName = "enemy_5";
            strBulletName = "enemy_shot_5";
            coinValue = 12;
            baseMovespeed = 800.0;
            health = 20;
            maxHealth = 40;
            damageOnCollision = 2;


            super.Init(app);

            fTimer1 = 1.0;
            bInThrustMode = true;

            moveFriction = 200.0;
        }

        override public function onTick():void
        {
            var theGame = theUtilities.theGame;

            if( theGame.gameState != 2 || theGame.playerShip == null)
                return;


            var moveVec:Point = moveVelocity;
            moveVec.normalize();

            sprite.rotation = (theUtilities.GetAngleFromVector( moveVec ) / 360) * 6.28;

            if( bInThrustMode )
            {
                var thrustVal:float = 800.0;
                if( bThrustingAway )
                    thrustVal = -1200.0;

                ThrustTowardPlayer(thrustVal);
                if( Math.random() < 0.2 )
                {
                    SpawnThrustParticle();
                    SpawnThrustParticle();
                }
            }
            else
            {
                fShotTimer -= deltaMS;
                if( fShotTimer < 0 )
                {
                    fShotTimer = 1.5 + Math.random() * 2.5;
                    FireShotAtPlayer(0.05, 300.0, 4);
                }

                thrust.x = 0;
                thrust.y = 0;
            }

            super.onTick();

            fTimer1 -= deltaMS;
            if( fTimer1 <= 0 )
            {
                bInThrustMode = !bInThrustMode;
                if( bInThrustMode )
                {
                    fTimer1 = 0.5;

                    var deltaVec:Point = theGame.playerShip.worldPosition - worldPosition;
                    if( deltaVec.length < 400 )
                        bThrustingAway = true;
                    else
                        bThrustingAway = false;
                }
                else
                    fTimer1 = 0.5 + Math.random() * 1.0;
            }

        }
    }

    public class shepEnemy_Type6 extends shepEnemy
    {
        var bInThrustMode:boolean;
        var fTimer1:float;

        override public function Init( app:LD48Game ):void
        {
            strSpriteName = "enemy_6";
            coinValue = 12;
            baseMovespeed = 400.0;
            health = 30;
            maxHealth = 30;
            damageOnCollision = 8;

            super.Init(app);

            fTimer1 = 1.0 + Math.random() * 2.0;

            moveFriction = 100.0;
        }

        override public function onTick():void
        {
            var theGame = theUtilities.theGame;

            if( theGame.gameState != 2 || theGame.playerShip == null)
                return;
            var moveVec:Point = moveVelocity;
            moveVec.normalize();

            sprite.rotation = (theUtilities.GetAngleFromVector( moveVec ) / 360) * 6.28;

            if( bInThrustMode )
            {
                ThrustTowardPlayer(900.0);
                if( Math.random() < 0.2 )
                {
                    SpawnThrustParticle();
                    SpawnThrustParticle();
                }
            }
            else
            {
                thrust.x = 0;
                thrust.y = 0;
            }

            super.onTick();

            fTimer1 -= deltaMS;
            if( fTimer1 <= 0 )
            {
                bInThrustMode = !bInThrustMode;
                if( bInThrustMode )
                    fTimer1 = 0.25 + Math.random() * 0.15;
                else
                    fTimer1 = 0.75 + Math.random() * 0.25;
            }

        }
    }

    public class shepEnemy_Type7_2 extends shepEnemy_Type7
    {
        override public function Init( app:LD48Game ):void
        {
            strSpriteName = "enemy_7_flip";
            coinValue = 40;
            baseMovespeed = 2000.0;
            health = 200;
            maxHealth = 200;
            damageOnCollision = 20;

            faction = 0;

            sprite = new Image(Texture.fromAsset("assets/" + strSpriteName + ".png"));

            moveVelocity = new Point(0,0);
            moveVelocity.x = (-1.0 + Math.random() * 2.0) * baseMovespeed;
            moveVelocity.y = (-1.0 + Math.random() * 2.0) * baseMovespeed;
            sprite.center();


            jumpInTimer = 0.7 + Math.random() * 0.4;

            moveFriction = 100.0;
        }
    }

    public class shepEnemy_Type7 extends shepEnemy
    {
        protected var bInThrustMode:boolean;
        protected var jumpInTimer:float;
        protected var launchShipTimer:float;

        override public function Init( app:LD48Game ):void
        {
            strSpriteName = "enemy_7";
            coinValue = 40;
            baseMovespeed = 2000.0;
            health = 200;
            maxHealth = 200;
            damageOnCollision = 20;

            super.Init(app);

            jumpInTimer = 0.7 + Math.random() * 0.4;

            moveFriction = 100.0;
        }

        override public function onTick():void
        {            
            var theGame = theUtilities.theGame;

            if( theGame.gameState != 2 || theGame.playerShip == null)
                return;

            var moveVec:Point = moveVelocity;
            moveVec.normalize();

            sprite.rotation = (theUtilities.GetAngleFromVector( moveVec ) / 360) * 6.28;

            if( jumpInTimer > 0.0 )
            {
                jumpInTimer -= deltaMS;
                thrust.x = moveVec.x * 1000;
                thrust.y = moveVec.y * 1000;
                if( Math.random() < 0.2 )
                {
                    SpawnThrustParticle();
                    SpawnThrustParticle();
                }
            }

            else
            {
                moveVelocity.x = moveVec.x * 20;
                moveVelocity.y = 0;
                thrust.x = 0.0;
                thrust.y = 0.0;
                moveFriction = 0.0;
            }

            super.onTick();

            if( jumpInTimer > 0.0 )
            {
                jumpInTimer -= deltaMS;
            }
            else
            {
                launchShipTimer -= deltaMS;
                if( launchShipTimer <= 0 )
                {
                    //launchuu shippuu
                    var newEnemy:shepEnemy = theUtilities.theGame.SpawnEnemy(3, worldPosition);
                    newEnemy.moveVelocity.x *= 1.25;
                    newEnemy.moveVelocity.y *= 1.25;
                    launchShipTimer = 2.0 + Math.random() * 0.75;
                }

            }
        }
    }







    public class shepEnemy_Type8 extends shepEnemy
    {

        override public function Init( app:LD48Game ):void
        {
            health = 140;
            maxHealth = 140;
            strSpriteName = "enemy_8";
            coinValue = 50;
            damageOnCollision = 50;
            baseMovespeed = 50.0;
            super.Init(app);

        }

        override public function OnDeath():void
        {

            var theGame:LD48Game = theUtilities.theGame;
            super.OnDeath();

            var newEnemy:shepEnemy = theGame.SpawnEnemy(4, worldPosition);
            newEnemy.moveVelocity.x *= 1.25;
            newEnemy.moveVelocity.y *= 1.25;
            
            newEnemy = theGame.SpawnEnemy(4, worldPosition);
            newEnemy.moveVelocity.x *= 1.25;
            newEnemy.moveVelocity.y *= 1.25;

        }
    }

       public class shepEnemy_Type9 extends shepEnemy
    {
        var bInThrustMode:boolean;
        var fTimer1:float;
        var bThrustingAway:boolean;

        var fShotTimer:float;
        var iShotVolleyCount:int;


        override public function Init( app:LD48Game ):void
        {
            strSpriteName = "enemy_9";
            strBulletName = "enemy_shot_9";
            coinValue = 300;
            baseMovespeed = 800.0;
            health = 400;
            maxHealth = 400;
            damageOnCollision = 0;
            noCollide = true;

            super.Init(app);

            fTimer1 = 1.0;
            bInThrustMode = true;

            moveFriction = 200.0;
            iShotVolleyCount = 9;
            coinTossBoost = 400.0;
        }

        override public function onTick():void
        {
            var theGame = theUtilities.theGame;

            if( theGame.gameState != 2 || theGame.playerShip == null)
                return;            

            var moveVec:Point = moveVelocity;
            moveVec.normalize();

            sprite.rotation = 0;

            if( bInThrustMode )
            {
                var thrustVal:float = 1200.0;
                if( bThrustingAway )
                    thrustVal = -300.0;

                ThrustTowardPlayer(thrustVal);
                if( Math.random() < 0.2 )
                {
                    SpawnThrustParticle();
                    SpawnThrustParticle();
                }
            }
            else
            {
                thrust.x = 0;
                thrust.y = 0; 
            }

            fShotTimer -= deltaMS;
            if( fShotTimer < 0 )
            {
                fShotTimer = 0.3;
                FireShotAtPlayer(0.05,800.0, 15);
                iShotVolleyCount--;
                if( iShotVolleyCount <= 0 )
                {
                    fShotTimer = 3.0 + Math.random() * 2.0;
                    iShotVolleyCount = 9;
                }
            }

            super.onTick();

            fTimer1 -= deltaMS;
            if( fTimer1 <= 0 )
            {
                bInThrustMode = !bInThrustMode;
                if( bInThrustMode )
                {
                    fTimer1 = 0.5;

                    var deltaVec:Point = theGame.playerShip.worldPosition - worldPosition;
                    if( deltaVec.length < 300 )
                        bThrustingAway = true;
                    else
                        bThrustingAway = false;
                }
                else
                    fTimer1 = 0.5 + Math.random() * 1.0;
            }

        }
    }

}