package
{
    import loom.Application;

    import loom2d.display.Image;
    import loom2d.display.StageScaleMode;
    import loom2d.display.Sprite;
    import loom2d.display.Stage;

    import loom2d.textures.Texture;

    import loom2d.ui.SimpleLabel;

    import loom2d.math.Point;
    import loom2d.math.Rectangle;
    import loom2d.math.Color;

    import loom2d.events.KeyboardEvent;

    import loom.gameframework.TimeManager;
    import loom.gameframework.ITicked;

    import loom.platform.LoomKey;

    public static class theMonsterSpawner implements ITicked
    {
        static var theGame:LD48Game;

        static var timeTillNextWave:float;
        public static var bFirstPickupGet:boolean;

        public static var lastUpdateTime:float;
        public static var playerShip:shepPlayerShip;

        protected static var deltaMS:float;

        public static override function onTick():void
        {

            if( theUtilities == null )
                return;

            var oldTime = lastUpdateTime;
            lastUpdateTime = theUtilities.time.virtualTime;
            deltaMS = lastUpdateTime - oldTime;
            deltaMS /= 1000.0;

            if( theUtilities.theGame == null )
                return;

            theGame = theUtilities.theGame;

            if( theGame.gameState != 2)
                return;

            if( theGame.playerShip == null )
                return;

            playerShip = theGame.playerShip;

            if( !bFirstPickupGet )
                return;

            timeTillNextWave -= deltaMS;
            if( timeTillNextWave < 0.0)
            {
                SpawnNewWave();
            }

        }

        static function SpawnMonsterAroundEdge( montype:int):shepEnemy
        {
            var spawnPoint = new Point( (-1 + Math.random() * 2), (-1 + Math.random() * 2));
            spawnPoint.normalize();
            
            spawnPoint.x *= 1100;
            spawnPoint.y *= 700;

            spawnPoint.x += playerShip.worldPosition.x;
            spawnPoint.y += playerShip.worldPosition.y;

            var newEnemy:shepEnemy = theGame.SpawnEnemy( montype, spawnPoint);

            var delta:Point = playerShip.worldPosition - newEnemy.worldPosition;
            delta.normalize();
            delta.x += (-0.05 + Math.random() * 0.1);
            delta.y += (-0.05 + Math.random() * 0.1);

            if( montype == 4 )  
            {
                delta.x *= 200;
                delta.y *= 200;
                newEnemy.rotationVelocity = ( -6.28 + Math.random() * 12.54);
            }
            else
            {
                delta.x *= 400;
                delta.y *= 400;
            }

            newEnemy.moveVelocity = delta;
            if( montype == 2 || montype == 4)  
                newEnemy.moveFriction = 0.0;

            trace("Enemy pos " + newEnemy.worldPosition + " Player Pos " + playerShip.worldPosition + " my direction " + newEnemy.moveVelocity);

            return newEnemy;
        }

        public static function SpawnEnemy7():void
        {
            var dir:int = 1;
            if( Math.random() < 0.5)
                dir = -1;

            var yDir:int = 1;
            if( Math.random() < 0.5)
                yDir = -1;

            var spawnPoint:Point = playerShip.worldPosition;
            spawnPoint.x += 1000 * dir;

            spawnPoint.y += ( 150 + Math.random() * 275) * yDir;

            var newEnemy:shepEnemy = null;
            if( spawnPoint.x < playerShip.worldPosition.x )
            {
                trace("spawning type 2");
                newEnemy = theGame.SpawnEnemy( 72, spawnPoint);
            }

            else
                newEnemy = theGame.SpawnEnemy( 7, spawnPoint);

            newEnemy.moveVelocity.x = 2000.0 * (dir * -1);
            newEnemy.moveVelocity.y = 0;

        }

        public static function SpawnNewWave():void
        {
            //trace("Spawn new wave!");
            var spawnNum:int = theGame.playerShip.powerLevel;
            

            if( spawnNum != 1)  
            {
                var dieRoll:float = Math.random();
                if( dieRoll < 0.33 )
                    spawnNum--;
                else if( dieRoll > 0.66)
                    spawnNum++;
            }

            spawnNum = Math.floor(spawnNum);

            trace("SpawnNewWave: Playerlevel " + theGame.playerShip.powerLevel + ", spawnRank " + spawnNum);

            var idx:int;

            switch( spawnNum )
            {
                //asteroid time!
                case 1:
                    timeTillNextWave = 12.0;
                    for( idx = 0; idx < 8; idx++)
                    {
                        SpawnMonsterAroundEdge(2);
                    }
                    break;
                case 2:
                    timeTillNextWave = 10.0;
                    for( idx = 0; idx < 12; idx++)
                    {
                        SpawnMonsterAroundEdge(2);
                    }
                    break;
                case 3:
                    timeTillNextWave = 10.0;
                    for( idx = 0; idx < 4; idx++)
                    {
                        SpawnMonsterAroundEdge(2);
                    }
                    for( idx = 0; idx < 6; idx++)
                    {
                        SpawnMonsterAroundEdge(3);
                    }
                                        break;
                case 4:
                    timeTillNextWave = 5.0;
                    for( idx = 0; idx < 2; idx++)
                    {
                        SpawnMonsterAroundEdge(2);
                    }
                    for( idx = 0; idx < 6; idx++)
                    {
                        SpawnMonsterAroundEdge(4);
                    }
                    break;                    
                case 5:
                    timeTillNextWave = 10.0;
                    for( idx = 0; idx < 4; idx++)
                    {
                        SpawnMonsterAroundEdge(3);
                    }
                    for( idx = 0; idx < 6; idx++)
                    {
                        SpawnMonsterAroundEdge(5);
                    }
                    break;                    
                case 6:
                    timeTillNextWave = 10.0;
                    for( idx = 0; idx < 3; idx++)
                    {
                        SpawnMonsterAroundEdge(4);
                    }
                    for( idx = 0; idx < 2; idx++)
                    {
                        SpawnMonsterAroundEdge(5);
                    }
                    for( idx = 0; idx < 6; idx++)
                    {
                        SpawnMonsterAroundEdge(6);
                    }
                    break;      
                case 7:
                    timeTillNextWave = 10.0;
                    for( idx = 0; idx < 2; idx++)
                    {
                        SpawnEnemy7();
                    }
                    for( idx = 0; idx < 4; idx++)
                    {
                        SpawnMonsterAroundEdge(5);
                    }
                    break;  
                case 8:
                    timeTillNextWave = 10.0;
                    for( idx = 0; idx < 2; idx++)
                    {
                        SpawnMonsterAroundEdge(8);
                    }
                    for( idx = 0; idx < 4; idx++)
                    {
                        SpawnMonsterAroundEdge(6);
                    }
                    break; 
                case 9:
                    timeTillNextWave = 12.0;
                    SpawnMonsterAroundEdge(9);
                    for( idx = 0; idx < 2; idx++)
                    {
                        SpawnEnemy7();
                    }
                    for( idx = 0; idx < 5; idx++)
                    {
                        SpawnMonsterAroundEdge(6);
                    }
                    break; 
                case 10:
                    timeTillNextWave = 12.0;
                    SpawnMonsterAroundEdge(9);
                    SpawnMonsterAroundEdge(9);
                    for( idx = 0; idx < 4; idx++)
                    {
                        SpawnMonsterAroundEdge(8);
                    }


                default:
                    timeTillNextWave = 15.0;
                    for( idx = 0; idx < 2; idx++)
                    {
                        SpawnMonsterAroundEdge(8);
                    }
                    break;
            }

        }
    }
}