package
{
    import loom.Application;
    import loom2d.display.StageScaleMode;
    import loom2d.display.Image;

    import loom2d.textures.Texture;
    import loom2d.ui.SimpleLabel;
    import loom2d.events.KeyboardEvent;

    import loom2d.math.Point;
    import loom2d.math.Rectangle;
    import loom2d.math.Color;

    import loom.gameframework.TimeManager;
    import loom.gameframework.ITicked;
    import loom.gameframework.IAnimated;


    import loom.platform.LoomKey;

    import loom2d.display.Quad;


    public class shepPlayerShip extends shepCharacter
    {

        public var powerLevel:int;

        var thrustPoint_p1 = (180/360) * 6.28;

        var thrustPoint_p2Right = (160/360) * 6.28;
        var thrustPoint_p2Left = (200/360) * 6.28;

        var thrustPoint_p3Left = (210/360) * 6.28;
        var thrustPoint_p3Right = (150/360) * 6.28;
        var thrustPoint_p3Center = (180/360) * 6.28;

        var thrustPoint_p4Left = (220/360) * 6.28;
        var thrustPoint_p4Right = (140/360) * 6.28;
        var thrustPoint_p4Center1 = (215/360) * 6.28;
        var thrustPoint_p4Center2 = (145/360) * 6.28;

        var thrustPoint_p6Left = (190/360) * 6.28;
        var thrustPoint_p6Right = (170/360) * 6.28;

        var firePoint_p2Right = (30/360) * 6.28;
        var firePoint_p2Left = (330/360) * 6.28;

        var firePoint_p3Right:float = (90/360) * 6.28;
        var firePoint_p3Left:float = (-90/360) * 6.28;

        var firePoint_p4Center:float = (0/360) * 6.28;


        var firePoint_p5_1:float = (0/360) * 6.28;
        var firePoint_p5_2:float = (72/360) * 6.28;
        var firePoint_p5_3:float = (144/360) * 6.28;
        var firePoint_p5_4:float = (216/360) * 6.28;
        var firePoint_p5_5:float = (288/360) * 6.28;

        var firePoint_p6_1:float = (45/360)*6.28;
        var firePoint_p6_2:float = (90/360)*6.28;
        var firePoint_p6_3:float = (135/360)*6.28;
        var firePoint_p6_4:float = (225/360)*6.28;
        var firePoint_p6_5:float = (270/360)*6.28;
        var firePoint_p6_6:float = (315/360)*6.28;


        var autoLaserLeft1:shepAutoLaser;
        var autoLaserLeft2:shepAutoLaser;
        var autoLaserRight1:shepAutoLaser;
        var autoLaserRight2:shepAutoLaser;

        var autoLaserLeft3:shepAutoLaser;
        var autoLaserLeft4:shepAutoLaser;
        var autoLaserRight3:shepAutoLaser;
        var autoLaserRight4:shepAutoLaser;

        var bFireSide:boolean;

        public var shipHealth:float;
        var shipHealthForNextLevel:float;

        public override function Init( app:LD48Game ):void
        {
            super.Init( app );
            strBulletName = "pew";
        }

        public function SetPowerLevel( plevel:int ):void
        {
            var theGame:LD48Game = theUtilities.theGame;

            if( plevel < 0 )
            {
               plevel = 0;
               theGame.bGGAfterFlash = true;
               theGame.StartFlashDown();
            }
            else if( plevel > 9 )
            {
                plevel = 9;
                theGame.bVictoryAfterFlash = true;
                theGame.StartFlashUp();
            }

            //clean up autolasers
            if( powerLevel >= 6)
            {
                theGame.UnRegisterShepObject(autoLaserLeft1);
                theGame.UnRegisterShepObject(autoLaserRight1);
            }
            if( powerLevel >= 7)
            {
                theGame.UnRegisterShepObject(autoLaserLeft2);
                theGame.UnRegisterShepObject(autoLaserRight2);
            }
            if( powerLevel == 9)
            {
                theGame.UnRegisterShepObject(autoLaserLeft3);
                theGame.UnRegisterShepObject(autoLaserRight3);
                theGame.UnRegisterShepObject(autoLaserLeft4);
                theGame.UnRegisterShepObject(autoLaserRight4);
            }            

            if( theGame.bVictoryAfterFlash || theGame.bGGAfterFlash )
                return;


            if( plevel > powerLevel )
                theGame.StartFlashUp();
            else if( plevel < powerLevel )
                theGame.StartFlashDown();                



            var oldrot = 0.0;
            if( sprite != null )
            {
                oldrot = sprite.rotation;
                theGame.GetStage().removeChild(sprite);
            }
            powerLevel = plevel;
            sprite = new Image(Texture.fromAsset("assets/p_level" + powerLevel + ".png"));
            sprite.center();
            sprite.rotation = oldrot;
            theGame.GetStage().addChild(sprite);

            switch( powerLevel )
            {
                case 0:
                    baseMovespeed = 100.0;
                    shipHealth = 5;
                    shipHealthForNextLevel = 10;
                    break;
                case 1:
                    baseMovespeed = 150.0;
                    shipHealth = 25;
                    shipHealthForNextLevel = 50;
                    break;
                case 2:
                    baseMovespeed = 200.0;
                    shipHealth = 30;
                    shipHealthForNextLevel = 60;
                    break;
                case 3:
                    baseMovespeed = 300.0;
                    shipHealth = 50;
                    shipHealthForNextLevel = 100;
                    break;
                case 4:
                    baseMovespeed = 400.0;
                    shipHealth = 60;
                    shipHealthForNextLevel = 120;
                    break;
                 case 5:
                    baseMovespeed = 400.0;
                    shipHealth = 75;
                    shipHealthForNextLevel = 150;
                    break;
                 case 6:
                    baseMovespeed = 300.0;
                    shipHealth = 200;
                    shipHealthForNextLevel = 400;

                    if( autoLaserLeft1 == null )
                        autoLaserLeft1 = GenerateAutoLaser();

                    if( autoLaserRight1 == null )
                        autoLaserRight1 = GenerateAutoLaser();

                    theGame.RegisterShepObject(autoLaserLeft1);
                    theGame.RegisterShepObject(autoLaserRight1);
                    break;

                 case 7:
                    baseMovespeed = 300.0;
                    shipHealth = 300;
                    shipHealthForNextLevel = 600;

                    if( autoLaserLeft1 == null )
                        autoLaserLeft1 = GenerateAutoLaser();

                    if( autoLaserRight1 == null )
                        autoLaserRight1 = GenerateAutoLaser();

                    if( autoLaserLeft2 == null )
                        autoLaserLeft2 = GenerateAutoLaser();

                    if( autoLaserRight2 == null )
                        autoLaserRight2 = GenerateAutoLaser();

                    theGame.RegisterShepObject(autoLaserLeft1);
                    theGame.RegisterShepObject(autoLaserRight1);
                    theGame.RegisterShepObject(autoLaserLeft2);
                    theGame.RegisterShepObject(autoLaserRight2);
                    break;

                case 8:
                    baseMovespeed = 400.0;
                    shipHealth = 400;
                    shipHealthForNextLevel = 800;

                    if( autoLaserLeft1 == null )
                        autoLaserLeft1 = GenerateAutoLaser();

                    if( autoLaserRight1 == null )
                        autoLaserRight1 = GenerateAutoLaser();

                    if( autoLaserLeft2 == null )
                        autoLaserLeft2 = GenerateAutoLaser();

                    if( autoLaserRight2 == null )
                        autoLaserRight2 = GenerateAutoLaser();

                    theGame.RegisterShepObject(autoLaserLeft1);
                    theGame.RegisterShepObject(autoLaserRight1);
                    theGame.RegisterShepObject(autoLaserLeft2);
                    theGame.RegisterShepObject(autoLaserRight2);
                    break;

                case 9:
                    baseMovespeed = 600.0;
                    shipHealth = 1000;
                    shipHealthForNextLevel = 2000;

                    if( autoLaserLeft1 == null )
                        autoLaserLeft1 = GenerateAutoLaser();

                    if( autoLaserRight1 == null )
                        autoLaserRight1 = GenerateAutoLaser();

                    if( autoLaserLeft2 == null )
                        autoLaserLeft2 = GenerateAutoLaser();

                    if( autoLaserRight2 == null )
                        autoLaserRight2 = GenerateAutoLaser();

                    if( autoLaserLeft3 == null )
                        autoLaserLeft3 = GenerateAutoLaser();

                    if( autoLaserRight3 == null )
                        autoLaserRight3 = GenerateAutoLaser();

                    if( autoLaserLeft4 == null )
                        autoLaserLeft4 = GenerateAutoLaser();

                    if( autoLaserRight4 == null )
                        autoLaserRight4 = GenerateAutoLaser();                        

                    theGame.RegisterShepObject(autoLaserLeft1);
                    theGame.RegisterShepObject(autoLaserRight1);
                    theGame.RegisterShepObject(autoLaserLeft2);
                    theGame.RegisterShepObject(autoLaserRight2);

                    theGame.RegisterShepObject(autoLaserLeft3);
                    theGame.RegisterShepObject(autoLaserRight3);
                    theGame.RegisterShepObject(autoLaserLeft4);
                    theGame.RegisterShepObject(autoLaserRight4);
                    break;

            }

            theGame.playerHealthBar.ForceValue(0.5);
        }


        function GenerateAutoLaser():shepAutoLaser
        {
            var newLazar = new shepAutoLaser();

            newLazar.sprite = new Image(Texture.fromAsset("assets/player_cannon.png"));
            newLazar.sprite.center();
            newLazar.sprite.depth = 0.2;
            newLazar.Init( theUtilities.theGame );
            newLazar.connectedShip = this;

            return newLazar;
        }

        override public function LaunchAttack():void
        {
            var theGame = theUtilities.theGame;
            var oldSpriteRot:float = sprite.rotation;

            switch( powerLevel )
            {
                case 0:
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation), 32, 300.0);
                    break;
                case 1:
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation), 32, 700.0);
                    break;
                case 2:
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p2Left), 60.0, 700.0);
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p2Right), 60.0, 700.0);
                    break;
                case 3:
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation), 32, 700.0);
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p3Left), 50.0, 700.0);
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p3Right), 50.0, 700.0);
                    break;
                case 4:
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p3Left), 50.0, 700.0);
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p3Right), 50.0, 700.0);

                    for( var wackyShot:int = 0; wackyShot < 3; wackyShot++)
                    {
                        sprite.rotation = oldSpriteRot + ( -0.4 + Math.random() * 0.8);
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p4Center), 64,1200.0);
                    }
                    sprite.rotation = oldSpriteRot;
                    break;
                case 5:
                    for( var spinnyShot:int = 0; spinnyShot < 5; spinnyShot++)
                    {
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation ), 50.0, 700.0);
                        sprite.rotation += 6.28 / 5;
                    }

                    sprite.rotation = oldSpriteRot;
                    break;
                case 6:
                    if( bFireSide )
                    {
                        sprite.rotation = oldSpriteRot + firePoint_p6_2;
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation ), 40.0, 450.0);
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_1), 40.0, 450.0);
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_6 ), 40.0, 450.0);
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_2), 60.0, 450.0);
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_5 ), 60.0, 450.0);
                    }
                    else
                    {
                        sprite.rotation = oldSpriteRot + firePoint_p6_5;
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation ), 40.0, 450.0);
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_1), 40.0, 450.0);
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_6 ), 40.0, 450.0);
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_2), 60.0, 450.0);
                        theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_5 ), 60.0, 450.0);
                    }

                    bFireSide = !bFireSide;

                    sprite.rotation = oldSpriteRot;
                    break;
                case 7:
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + ( -1.0 + (Math.random() * 2.0)) ), 40.0, 300.0 + Math.random() * 700.0);
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_6 + ( -0.6 + (Math.random() * 1.2)) ), 40.0, 300.0 + Math.random() * 700.0);
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_1 + ( -0.6 + (Math.random() * 1.2)) ), 40.0, 300.0 + Math.random() * 700.0);
                    break;
                case 8:
                    sprite.rotation = autoLaserLeft1.sprite.rotation;
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation ), 40.0, 300.0 + Math.random() * 700.0);
                    sprite.rotation = autoLaserLeft2.sprite.rotation;
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation ), 40.0, 300.0 + Math.random() * 700.0);
                    sprite.rotation = autoLaserRight1.sprite.rotation;
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation ), 40.0, 300.0 + Math.random() * 700.0);
                    sprite.rotation = autoLaserRight2.sprite.rotation;
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation ), 40.0, 300.0 + Math.random() * 700.0);
                    sprite.rotation = oldSpriteRot;
                    break;
                case 9:
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + ( -1.0 + (Math.random() * 2.0)) ), 40.0, 300.0 + Math.random() * 700.0);
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_6 + ( -0.6 + (Math.random() * 1.2)) ), 40.0, 500.0 + Math.random() * 700.0);
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_1 + ( -0.6 + (Math.random() * 1.2)) ), 40.0, 500.0 + Math.random() * 700.0);
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_5 + ( -0.6 + (Math.random() * 1.2)) ), 40.0, 500.0 + Math.random() * 700.0);
                    theGame.LaunchBullet(this, theUtilities.GetVectorFromAngle( sprite.rotation + firePoint_p6_2 + ( -0.6 + (Math.random() * 1.2)) ), 40.0, 500.0 + Math.random() * 700.0);
                    break;
            }

        }

        public override function onTick():void
        {
            var theGame = theUtilities.theGame;

            super.onTick();
            if( shipHealth >= shipHealthForNextLevel)
                SetPowerLevel(powerLevel +1 );
            else if( shipHealth <= 0 )
                SetPowerLevel(powerLevel -1 );

            theGame.playerHealthBar.targetValue = shipHealth / shipHealthForNextLevel;

            //position the autolasers correctly
            if( powerLevel == 6 )
            {
                PositionAutoLaser( autoLaserLeft1, (270/360) * 6.28, 40);
                PositionAutoLaser( autoLaserRight1, (90/360) * 6.28, 40);
            }
            else if( powerLevel == 7)
            {
                PositionAutoLaser( autoLaserLeft1, (300/360) * 6.28, 40);
                PositionAutoLaser( autoLaserRight1, (60/360) * 6.28, 40);
                PositionAutoLaser( autoLaserLeft2, (240/360) * 6.28, 40);
                PositionAutoLaser( autoLaserRight2, (120/360) * 6.28, 40);
            }
            else if( powerLevel == 8  )
            {
                PositionAutoLaser( autoLaserLeft1, (315/360) * 6.28, 64);
                PositionAutoLaser( autoLaserRight1, (45/360) * 6.28, 64);
                PositionAutoLaser( autoLaserLeft2, (225/360) * 6.28, 64);
                PositionAutoLaser( autoLaserRight2, (135/360) * 6.28, 64);
            }
            else if( powerLevel == 9)
            {
                PositionAutoLaser( autoLaserLeft1, (330/360) * 6.28, 60);
                PositionAutoLaser( autoLaserLeft2, (300/360) * 6.28, 40);
                PositionAutoLaser( autoLaserLeft3, (240/360) * 6.28, 40);
                PositionAutoLaser( autoLaserLeft4, (210/360) * 6.28, 60);

                PositionAutoLaser( autoLaserRight1, (30/360) * 6.28, 60);
                PositionAutoLaser( autoLaserRight2, (60/360) * 6.28, 40);
                PositionAutoLaser( autoLaserRight3, (120/360) * 6.28, 40);
                PositionAutoLaser( autoLaserRight4, (150/360) * 6.28, 60);
            }
        }

        function PositionAutoLaser( laser:shepAutoLaser, angle:float, dist:float )
        {
            var vec:Point = theUtilities.GetVectorFromAngle(sprite.rotation + angle);
            laser.worldPosition = worldPosition;
            laser.worldPosition.x += vec.x * dist;
            laser.worldPosition.y += vec.y * dist;
            laser.fireAngleRelativeToShip = angle;
        }

        override public function CollideWithPowerup( p:shepCollectable ):Boolean
        {
            if( p.alreadyCollectedGoAway )
                return false;

            if( p.bIncreasePlayerPowerLevel )
                SetPowerLevel( powerLevel +1 );

            shipHealth += p.value;

            theUtilities.theGame.UnRegisterShepObject(p);
            p.bActive = false;

            theMonsterSpawner.bFirstPickupGet = true;

            p.alreadyCollectedGoAway = true;
            return true;
        }

        public function CollideWithEnemy( e:shepEnemy ):void
        {
            if( e.noCollide)
                return;

            TakeDamage(e.damageOnCollision);
            theUtilities.theGame.UnRegisterShepObject(e);
            e.health = 0;
        }


        public function DecreasePowerLevel()
        {
            var theGame = theUtilities.theGame;

            if( powerLevel > 0 )
                SetPowerLevel( powerLevel -1 );
        }

        public function TakeDamage( d:float ):boolean
        {

            var theGame = theUtilities.theGame;

            shipHealth -= d;

            var onebones:int = d;
            if( onebones > 8)
                onebones = 8;

            for( var t:int = 0; t < 8; t++)
            {
                var launchDir:Point = new Point( -1.0 + Math.random() * 2.0, -1.0 + Math.random() * 2.0);
                launchDir.normalize(1);
                var randSpeed:float = 200.0 + Math.random() * 200.0;

                launchDir.x *= randSpeed;
                launchDir.y *= randSpeed;

                var strNum:string = "1";
                if( Math.random() > 0.5 )
                    strNum = "2";

                theGame.SpawnImageParticle( "player_shrapnel_" + strNum, worldPosition, launchDir, new Point(0,0), 1.0, new Color(255,255,255,255), 16.0,2.0,1.0, -5.0 + Math.random() * 10.0 );
            }

            return true;
        }


        override public function SpawnThrustParticle():void
        {
            var theGame = theUtilities.theGame;

            var spawnDir:Point = thrust;
            spawnDir.x *= -1;
            //spawnDir.y *= -1;

            spawnDir.normalize(1);

            spawnDir.x += (-0.2 + Math.random() * 0.4);
            spawnDir.y += (-0.2 + Math.random() * 0.4);

            spawnDir.x *= 275;
            spawnDir.y *= 275;

            spawnDir.x += moveVelocity.x;
            spawnDir.y += moveVelocity.y;


            var thrustLoc:Point;

            switch( powerLevel )
            {
                case 0:
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p1,32), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 2.0,0.5,1.0 );
                    break;
                case 1:
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p1,48), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    break;
                case 2:
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p2Left,48), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p2Right,48), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    break;
                case 3:
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p3Center,48), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p3Left,48), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p3Right,48), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    break;
                case 4:
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p4Center1,70), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p4Center2,70), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p4Left,70), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p4Right,70), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    break;

                case 5:
                    theGame.SpawnQuadParticle( SetThrustOffset(firePoint_p5_1,70), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 2.0,0.75,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(firePoint_p5_2,70), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 2.0,0.75,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(firePoint_p5_5,70), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 2.0,0.75,1.0 );

                    theGame.SpawnQuadParticle( SetThrustOffset(firePoint_p5_3,70), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 5.0,1.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(firePoint_p5_4,70), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 5.0,1.0,1.0 );
                    break;
                case 6:
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p6Left,100), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p6Right,100), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    break;
                case 7:
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p3Center,64), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p3Left,64), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p3Right,64), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,1.0,1.0 );
                    break;
                case 8:
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p3Center,64), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,2.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p3Left,64), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,2.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p3Right,64), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 4.0,2.0,1.0 );
                    break;
                case 9:
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p1,48), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 6.0,2.0,1.0 );
                    theGame.SpawnQuadParticle( SetThrustOffset(thrustPoint_p1,48), spawnDir, new Point(0,0), 0, new Color(255,210,16,255), 6.0,2.0,1.0 );
                    break;                           
            }
               

        }

    }


}