package
{
    import loom.Application;
    import loom2d.display.StageScaleMode;
    import loom2d.display.Image;

    import loom2d.textures.Texture;
    import loom2d.ui.SimpleLabel;
    import loom2d.events.KeyboardEvent;

    import loom2d.math.Point;
    import loom2d.math.Rectangle;
    import loom2d.math.Color;

    import loom.gameframework.TimeManager;
    import loom.gameframework.ITicked;
    import loom.gameframework.IAnimated;


    import loom.platform.LoomKey;

    import loom2d.display.Quad;

    public class shepObject implements ITicked, IAnimated 
    {
        public var lastUpdateTime:float;
        protected var deltaMS:float;

        [Inject]
        public var time:TimeManager;

        public function Init( app:LD48Game ): void {}
        public function RegisterDrawElements( app:LD48Game ):void {}
        public function UnRegisterDrawElements( app:LD48Game ):void {}
        override public function onTick():void {}
        override public function onFrame():void {}

    }
    public class shepActor extends shepObject
    {
        public var sprite:Image;
        public var moveDir:Point;
        public var clipRect:Rectangle;

        public var rotationVelocity:float;
        public var moveVelocity:Point;

        public var moveFriction:float;
        public var rotationFriction:float;

        public var thrust:Point;

        public var bPlayerControlled:Boolean;

        public var worldPosition:Point;

        public var faction:int;

        public function shepActor()
        {
        }

        public override function Init( app:LD48Game ):void
        {
        }

        public override function RegisterDrawElements( app:LD48Game ):void
        {
            app.GetStage().addChild(sprite);
        }

        public override function UnRegisterDrawElements( app:LD48Game ):void
        {
            app.GetStage().removeChild(sprite);
        }

        override public function onTick():void
        {
            var theGame:LD48Game = theUtilities.theGame;
         
            var oldTime = lastUpdateTime;
            lastUpdateTime = theUtilities.time.virtualTime;
            deltaMS = lastUpdateTime - oldTime;
            deltaMS /= 1000.0;

            //slow your roll
            if( rotationVelocity < 0.0)
            {
                rotationVelocity += rotationFriction * deltaMS;
                if( rotationVelocity > 0.0 )
                    rotationVelocity = 0.0;
            }
            else if( rotationVelocity > 0.0 )
            {
                rotationVelocity -= rotationFriction * deltaMS;
                if( rotationVelocity < 0.0 )
                    rotationVelocity = 0.0;
            }

            if( moveVelocity.x < 0)
            {
                moveVelocity.x += moveFriction * deltaMS;
                if( moveVelocity.x > 0.0 )
                    moveVelocity.x = 0.0;
            }
            else if( moveVelocity.x > 0 )
            {
                moveVelocity.x -= moveFriction * deltaMS;
                if( moveVelocity.x < 0.0 )
                    moveVelocity.x = 0.0;
            }

            if( moveVelocity.y < 0)
            {
                moveVelocity.y += moveFriction * deltaMS;
                if( moveVelocity.y > 0.0 )
                    moveVelocity.y = 0.0;
            }
            else if( moveVelocity.y > 0 )
            {
                moveVelocity.y -= moveFriction * deltaMS;
                if( moveVelocity.y < 0.0 )
                    moveVelocity.y = 0.0;
            }

            if( bPlayerControlled)
            {
                if( rotationVelocity > 180.0)
                    rotationVelocity = 180.0;
                else if( rotationVelocity < -180.0)
                    rotationVelocity = -180.0;
            }

            //Rotation measured in Rads
            sprite.rotation += (rotationVelocity / 360) * 6.28 * deltaMS;

            if( sprite.rotation > 6.28 )
                sprite.rotation -= 6.28;
            else if( sprite.rotation < 0 )
                sprite.rotation += 6.28;


            if( bPlayerControlled )
            {
                //trace("Velocity " + moveVelocity );
                //trace("Rotation " + sprite.rotation + " Facing" + facing );
            }

            var oldPos:Point = new Point( worldPosition.x, worldPosition.y);

            moveVelocity.x += thrust.x * deltaMS;
            moveVelocity.y -= thrust.y * deltaMS;

            worldPosition.x += moveVelocity.x * deltaMS;
            worldPosition.y += moveVelocity.y * deltaMS;

            clipRect = sprite.bounds;
            clipRect.x = worldPosition.x;
            clipRect.y = worldPosition.y;

            DoCollisionTick( oldPos );

            sprite.x = worldPosition.x - theGame.currentCameraPosition.x;
            sprite.y = worldPosition.y - theGame.currentCameraPosition.y;
        }

        protected function DoCollisionTick( oldPos:Point):void
        {
            if( theUtilities.theGame.gameState != 2)
                return;

            /*
            for(var t:int = 0, l:int = theCollision.walls.length;  t < l; t++)
            {
                var box:shepActor = theCollision.walls[t];
                if( box == this )
                    continue;

                if( clipRect.intersects( clipRect, box.clipRect ))
                {
                    HandleCollisionPositioning( box, oldPos);
                    break;
                }
            }
    */
            var distFromPlayer:Point = worldPosition - theUtilities.theGame.playerShip.worldPosition;
            if( distFromPlayer.length > 1200 )
                return;

            var distSQ:float = 0;

            if( Math.random() > 0.5 )
            {
                for(var t2:int = 0, l2:int = theCollision.projectiles.length;  t2 < l2; t2++)
                {
                    var bullet:shepBullet = theCollision.projectiles[t2];
                    if( bullet == null || bullet.bActive == false || bullet.faction == faction)
                        continue;

                    var bulletDelta:Point = bullet.worldPosition - worldPosition;
                    distSQ = bulletDelta.x * bulletDelta.x + bulletDelta.y * bulletDelta.y;
                    if( distSQ < (16 + (sprite.width/2) * (16 + (sprite.width/2) )))
                    {
                        CollideWithBullet( bullet );
                    }
                }
            }
            if( bPlayerControlled)
            {

                for(var t:int = 0, l:int = theCollision.bodies.length;  t < l; t++)
                {
                    var otherShip:shepActor = theCollision.bodies[t];
                    if( otherShip == this || otherShip == null )
                        continue;

                    var shipDelta:Point = otherShip.worldPosition - worldPosition;
                    distSQ = shipDelta.x * shipDelta.x + shipDelta.y * shipDelta.y;
                    if( distSQ < (otherShip.sprite.width / 2 + sprite.width / 2) * (otherShip.sprite.width / 2 + sprite.width / 2))
                    {
                        CollideWithEnemy( otherShip as shepEnemy );
                    }

                }

                for(var t3:int = 0, l3:int = theCollision.collectables.length;  t3 < l3; t3++)
                {
                    var pwrup:shepCollectable = theCollision.collectables[t3];
                    if( pwrup == null || pwrup.bActive == false)
                        continue;

                    var pwrDelta:Point = pwrup.worldPosition - worldPosition;
                    if( pwrDelta.length < 16 + (sprite.width/2))
                    {
                        CollideWithPowerup( pwrup );
                    }
                }

            }


        }

        public function HandleCollisionPositioning( box:shepActor, oldPos:Point ):void
        {
            var savedPoint:Point = new Point( worldPosition.x, worldPosition.y);
            worldPosition.x = oldPos.x;
            clipRect.x = worldPosition.x;
            clipRect.y = worldPosition.y;

            if(  clipRect.intersects( clipRect, box.clipRect ))
            {
                worldPosition.x = savedPoint.x;
                worldPosition.y = oldPos.y;
                clipRect.x = worldPosition.x;
                clipRect.y = worldPosition.y;

                if(  clipRect.intersects( clipRect, box.clipRect ))
                {
                    worldPosition.x = oldPos.x;
                    worldPosition.y = oldPos.y;
                    clipRect.x = worldPosition.x;
                    clipRect.y = worldPosition.y;

                }

            }

        }

        override public function onFrame():void
        {

        }

        public function OnDeath():void
        {

        }

        public function CollideWithBullet( b:shepBullet ):boolean
        {
            if( b.faction == faction )
                return false;

            //trace("Collision! Bullet faction " + b.faction + " and my faction!" + faction );
            b.OnDeliverHit();
            return true;

        }

        public function CollideWithEnemy( e:shepEnemy ):void
        {
        }

        public function CollideWithPowerup( p:shepCollectable ):Boolean
        {
            return false;
        }

    }

}