package
{
    import loom.Application;
    import loom2d.display.StageScaleMode;
    import loom2d.display.Image;

    import loom2d.textures.Texture;
    import loom2d.ui.SimpleLabel;
    import loom2d.math.Point;
    import loom2d.math.Rectangle;
    import loom2d.math.Color;

    import loom2d.events.KeyboardEvent;

    import loom.gameframework.TimeManager;
    import loom.gameframework.ITicked;

    import loom.platform.LoomKey;

    import loom2d.display.Quad;

    public class shepStar extends shepObject
    {
        public var screenPos:Point;
        public var speedMultiplier:float;

        public var starquad:Quad;
        public var size:float;

        var lastShipPos:Point;

        public override function RegisterDrawElements( app:LD48Game ):void
        {
            starquad = new Quad(size,size, new Color(255,255,255,255).toInt(), true);
            starquad.depth = 0.1;
            app.GetStage().addChild(starquad);
        }
        public override function UnRegisterDrawElements( app:LD48Game ):void
        {
            app.GetStage().removeChild(starquad);
        }

        override public function onTick():void
        {
            super.onTick();
            var theGame = theUtilities.theGame;

            if( theGame.gameState != 2 )
            {
                DoTitleStarfield();
            }
            else
            {
                //movement vector here is backwards on purpose
                var delta:Point = lastShipPos - theGame.playerShip.worldPosition;
                lastShipPos = theGame.playerShip.worldPosition;

                screenPos.x += delta.x * speedMultiplier;
                screenPos.y += delta.y * speedMultiplier;
            }
            CheckForWarp();
            SizeQuadCorrectly();
        }

        function SizeQuadCorrectly()
        {
            starquad.setVertexPosition(0, screenPos.x - size/2, screenPos.y - size/2);
            starquad.setVertexPosition(1, screenPos.x + size/2, screenPos.y - size/2);
            starquad.setVertexPosition(2, screenPos.x - size/2, screenPos.y + size/2);
            starquad.setVertexPosition(3, screenPos.x + size/2, screenPos.y + size/2);

        }

        function CheckForWarp():void
        {
            var theGame = theUtilities.theGame;
            var swidth:float = theGame.GetStage().stageWidth;
            var sheight:float = theGame.GetStage().stageHeight;

            if( screenPos.x < -100 )
            {
                screenPos.x = swidth + 100 + Math.random() * 100;
                screenPos.y = sheight * Math.random();
            }
            else if( screenPos.x > swidth + 100 )
            {
                screenPos.x = Math.random() - 100;
                screenPos.y = sheight * Math.random();
            }

            if( screenPos.y < -50 )
            {
                screenPos.x = swidth * Math.random();
                screenPos.y = sheight + 20 +  30 * Math.random();
            }
            else if( screenPos.y > sheight + 50 )
            {
                screenPos.x = swidth * Math.random();
                screenPos.y = -20 -30 * Math.random();
            }

        }

        function DoTitleStarfield():void
        {
            screenPos.x -= 800 * 0.016 * speedMultiplier;
        }
    }
}