package
{
    import loom.Application;
    import loom2d.display.StageScaleMode;
    import loom2d.display.Image;

    import loom2d.textures.Texture;
    import loom2d.ui.SimpleLabel;
    import loom2d.math.Point;
    import loom2d.math.Rectangle;
    import loom2d.math.Color;

    import loom2d.events.KeyboardEvent;

    import loom.gameframework.TimeManager;
    import loom.gameframework.ITicked;

    import loom.platform.LoomKey;

    import loom2d.display.Quad;

    public class shepStatusBar extends shepObject
    {
        public var xLoc:int;
        public var yLoc:int;
        public var Width:int;
        public var Height:int;

        public var changeSpeed:float;
        public var targetValue:float;

        public var fullColor:Color;
        public var emptyColor:Color;

        public var fullQuad:Quad;
        public var emptyQuad:Quad;

        var barDelta:float;
        var currentValue:float;


        public function Init( app:LD48Game ):void
        {
            fullColor = new Color(0,255,0,255);
            emptyColor = new Color(255,0,0,255);
            
            fullQuad = new Quad(0,0,fullColor.toInt(),false);
            emptyQuad = new Quad(0,0,emptyColor.toInt(),false);
        }

        public override function RegisterDrawElements( app:LD48Game ):void
        {
            fullQuad.depth = 1.0;
            emptyQuad.depth = 1.1;
            app.GetStage().addChild(fullQuad);
            app.GetStage().addChild(emptyQuad);
        }

        public override function UnRegisterDrawElements( app:LD48Game ):void
        {
            fullQuad.depth = 1.0;
            emptyQuad.depth = 1.1;
            app.GetStage().removeChild(fullQuad);
            app.GetStage().removeChild(emptyQuad);
        }

        public function ForceValue( newValue:float ):void
        {
            currentValue = newValue;
            targetValue = newValue;
        }

        override public function onTick():void
        {
            //update values to match:

            if( currentValue < targetValue )
            {
                currentValue += changeSpeed / 60.0;
                if( currentValue > targetValue )
                    currentValue = targetValue;
            }
            else if( currentValue > targetValue )
            {
                currentValue -= changeSpeed / 60.0;
                if( currentValue < targetValue )
                    currentValue = targetValue;
            }

            var xd:int = xLoc;
            var yd:int = yLoc;

            if( targetValue < currentValue )
            {
                //trace("tar: " + targetValue + " cur " + currentValue);
                xd += (-2 + Math.random() * 4);
                yd += (-2 + Math.random() * 4);
            }

            emptyQuad.setVertexPosition(0,xd + (Width * currentValue),yd);
            emptyQuad.setVertexPosition(1,xd + Width,yd);
            emptyQuad.setVertexPosition(2,xd + (Width * currentValue),yd + Height);
            emptyQuad.setVertexPosition(3,xd + Width,yd + Height);

            fullQuad.setVertexPosition(0,xd,yd);
            fullQuad.setVertexPosition(1,xd + (Width * currentValue),yd);
            fullQuad.setVertexPosition(2,xd,yd + Height);
            fullQuad.setVertexPosition(3,xd + (Width * currentValue),yd + Height);

            for( var t:int =0 ; t < 4; t++)
            {
                emptyQuad.setVertexColor(t, emptyColor.toInt());
                fullQuad.setVertexColor(t, fullColor.toInt());
            }

        }

        public function SetNewValue( val:float):void
        {
            targetValue = val;
            if( changeSpeed == 0.0)
                changeSpeed = 1.0;
        }

        public function SetNewValueAndSpeed( val:float, speed:float):void
        {
            targetValue = val;
            changeSpeed = speed;
        }
    }

}